/*
 @C:\Web_605\Sql\End_Conv\SqlServer\3917_CDPSTPS_CALCULA_INSUMOS_PESAGEM.SQL

 Descrio:
 Procedure para gerar os dados da tela de retirada a partir dos produtos pesados

 Parmetros

 P_CDFILIAL     - Cdigo da filial
 P_NRORDPROD    - Numero da ordem de produo
 P_NRSUBORDPROD - Numero da sub-op

 RAISERROR('', 16,1);
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CALCULA_INSUMOS_PESAGEM' AND
	        TYPE = 'P' 			      AND
	        U.UID = O.UID            AND
	        U.NAME = USER)
DROP PROCEDURE IMPOSTO_SAIDA
GO

CREATE PROCEDURE CALCULA_INSUMOS_PESAGEM
                     @P_CDFILIAL     VARCHAR(04),
                     @P_NRORDPROD    VARCHAR(10),
                     @P_NRSUBORDPROD VARCHAR(01)
AS
   DECLARE @V_COUNT         INTEGER;
   DECLARE @V_NRRETEST      VARCHAR(20);
   DECLARE @V_CDSETOR       VARCHAR(04);
   DECLARE @V_CDCENTCUST    VARCHAR(04);
   DECLARE @V_NRSEQRETPROD  INTEGER;
   DECLARE @V_CDTIPORETI    VARCHAR(2);
   DECLARE @V_CDPRODUTO     VARCHAR(10);
   DECLARE @V_DSFASE        VARCHAR(50);
   DECLARE @V_CDSETORAUX    VARCHAR(04);
   DECLARE @V_CDCENTCUSTAUX VARCHAR(04);

   DECLARE @V_RETIRADAESTO_CDFILIAL VARCHAR(04);
   DECLARE @V_RETIRADAESTO_NRRETEST VARCHAR(10);

   DECLARE @V_PRODACABADO_CDFILIAL     VARCHAR(04);
   DECLARE @V_PRODACABADO_NRORDPROD    VARCHAR(10);
   DECLARE @V_PRODACABADO_NRSUBORDPROD VARCHAR(01);
   DECLARE @V_PRODACABADO_IDORDPRODCON VARCHAR(01);
   DECLARE @V_PRODACABADO_CDSUBPRODETA VARCHAR(10);
   DECLARE @V_PRODACABADO_NRSUBPRETAOP VARCHAR(03);
   DECLARE @V_PRODACABADO_CDPRODUTO    VARCHAR(10);
   DECLARE @V_PRODACABADO_NRPRODACAB   VARCHAR(03);
   DECLARE @V_PRODACABADO_QTPRACABADO  DOUBLE PRECISION;
   DECLARE @V_PRODACABADO_NRLANCESTQ   VARCHAR(10);
   DECLARE @V_PRODACABADO_NRSEQUITEM   VARCHAR(04);
   DECLARE @V_PRODACABADO_QTPRODUZIDA  DOUBLE PRECISION;
   DECLARE @V_PRODACABADO_IDPRODUSUPL  VARCHAR(01);
   DECLARE @V_PRODACABADO_CDPROCFABRIC VARCHAR(10);

   DECLARE @V_NOVO_CODIGO_NT    VARCHAR(30);

   DECLARE @V_INSUMO_CDPRODUTO    VARCHAR(10);
   DECLARE @V_INSUMO_CDPROCFABRIC VARCHAR(10);
   DECLARE @V_INSUMO_CDETAPAPROD  VARCHAR(10);
   DECLARE @V_INSUMO_CDPRODINSUMO VARCHAR(10);
   DECLARE @V_INSUMO_IDUTAPRREQET VARCHAR(01);
   DECLARE @V_INSUMO_QTINSUMETAPA DOUBLE PRECISION;
   DECLARE @V_INSUMO_QTRENDINSU   DOUBLE PRECISION;
   DECLARE @V_INSUMO_IDSEMIACETAP VARCHAR(01);
   DECLARE @V_INSUMO_QTAPRODPREOP DOUBLE PRECISION;
   DECLARE @V_INSUMO_IDORDPRODCON VARCHAR(01);
   DECLARE @V_INSUMO_CDPLANPRODOP VARCHAR(10);
   DECLARE @V_INSUMO_NRORDPROD    VARCHAR(10);
   DECLARE @V_INSUMO_NRSUBORDPROD VARCHAR(01);
   DECLARE @V_INSUMO_DSFASE       VARCHAR(50);
   DECLARE @V_INSUMO_CDTIPOINSU   VARCHAR(03);
   DECLARE @V_INSUMO_IDLOTEEXT    VARCHAR(01);
BEGIN

   /*DELETA OS REGISTROS QUE AINDA NAO FORAM ATUALIZADOS ESTOQUE DA TELA DE RETIRADA*/
   DECLARE C_RETIRADAESTO CURSOR FOR
      SELECT CDFILIAL, NRRETEST
        FROM RETIRADAESTO
       WHERE CDFILIAL     = @P_CDFILIAL
         AND NRORDPROD    = @P_NRORDPROD
         AND NRSUBORDPROD = @P_NRSUBORDPROD
         AND NRLANCESTQ IS NULL;
   OPEN C_RETIRADAESTO;

   FETCH NEXT FROM C_RETIRADAESTO INTO @V_RETIRADAESTO_CDFILIAL, @V_RETIRADAESTO_NRRETEST;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      DELETE FROM RETIRADAESTO
      WHERE CDFILIAL = @V_RETIRADAESTO_CDFILIAL
        AND NRRETEST = @V_RETIRADAESTO_NRRETEST;

      DELETE FROM ITEMRETIEST
      WHERE CDFILIAL = @V_RETIRADAESTO_CDFILIAL
        AND NRRETEST = @V_RETIRADAESTO_NRRETEST;

      DELETE FROM LOTITRETIEST
      WHERE CDFILIAL = @V_RETIRADAESTO_CDFILIAL
        AND NRRETEST = @V_RETIRADAESTO_NRRETEST;

      FETCH NEXT FROM C_RETIRADAESTO INTO @V_RETIRADAESTO_CDFILIAL, @V_RETIRADAESTO_NRRETEST;
   END;
   CLOSE C_RETIRADAESTO;
   DEALLOCATE C_RETIRADAESTO;

   SELECT @V_CDSETOR = MAX(P.CDSETORPROD), @V_CDCENTCUST = MAX(S.CDCENTCUST), @V_CDTIPORETI = MAX(P.CDTIPORETI)
     FROM PARAMAN P LEFT JOIN SETOR S
                       ON P.CDSETORPROD = S.CDSETOR
    WHERE P.CDFILIAL = @P_CDFILIAL;

   /*REGERA OS DADOS DA TELA DE RETIRADA DE ACORDO COM OS PRODUTOS ACABADOS DA OP
     SE O PRODUTO DA OP FOI PESADO E GERADO DE ACORDO COM A QUANTIDADE PESADA*/
   DECLARE C_PRODACABADO CURSOR FOR
      SELECT O.CDFILIAL, O.NRORDPROD, O.NRSUBORDPROD, O.IDORDPRODCON, P.CDSUBPRODETA, P.NRSUBPRETAOP, P.CDPRODUTO, P.NRPRODACAB,
             P.QTPRACABADO, P.NRLANCESTQ, P.NRSEQUITEM, ISNULL(P.QTLIQACUM, O.QTAPRODPREOP) QTPRODUZIDA, ISNULL(P.IDPRODUSUPL, 'N') IDPRODUSUPL,
             O.CDPROCFABRIC
        FROM ORDPRODUCAO O, PRODACABADO P
       WHERE O.CDFILIAL = @P_CDFILIAL
         AND O.NRORDPROD = @P_NRORDPROD
         AND O.NRSUBORDPROD = @P_NRSUBORDPROD
         AND O.CDFILIAL = P.CDFILIAL
         AND O.NRORDPROD = P.NRORDPROD
         AND O.NRSUBORDPROD = P.NRSUBORDPROD
         AND ISNULL(P.IDPRODUSUPL, 'N')  <> 'S'
       UNION ALL
      SELECT O.CDFILIAL, O.NRORDPROD, O.NRSUBORDPROD, O.IDORDPRODCON, P.CDSUBPRODETA, P.NRSUBPRETAOP, P.CDPRODUTO, P.NRPRODACAB,
             P.QTPRACABADO, P.NRLANCESTQ, P.NRSEQUITEM, P.QTLIQACUM QTPRODUZIDA, ISNULL(P.IDPRODUSUPL, 'N') IDPRODUSUPL,
             O.CDPROCFABRIC
        FROM ORDPRODUCAO O, PRODACABADO P
       WHERE O.CDFILIAL = P_CDFILIAL
         AND O.NRORDPROD = P_NRORDPROD
         AND O.NRSUBORDPROD = P_NRSUBORDPROD
         AND O.CDFILIAL = P.CDFILIAL
         AND O.NRORDPROD = P.NRORDPROD
         AND O.NRSUBORDPROD = P.NRSUBORDPROD
         AND ISNULL(P.QTLIQACUM,0) <> 0
         AND P.IDPRODUSUPL  = 'S';       
   OPEN C_PRODACABADO;

   FETCH NEXT FROM C_PRODACABADO INTO @V_PRODACABADO_CDFILIAL, @V_PRODACABADO_NRORDPROD, @V_PRODACABADO_NRSUBORDPROD, @V_PRODACABADO_IDORDPRODCON, @V_PRODACABADO_CDSUBPRODETA, @V_PRODACABADO_NRSUBPRETAOP, @V_PRODACABADO_CDPRODUTO, @V_PRODACABADO_NRPRODACAB,
                                      @V_PRODACABADO_QTPRACABADO, @V_PRODACABADO_NRLANCESTQ, @V_PRODACABADO_NRSEQUITEM, @V_PRODACABADO_QTPRODUZIDA, @V_PRODACABADO_IDPRODUSUPL,
                                      @V_PRODACABADO_CDPROCFABRIC;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_PRODACABADO_IDORDPRODCON = 'C' BEGIN
         DECLARE C_INSUMO CURSOR FOR
            SELECT I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, I.IDUTAPRREQET, I.QTINSUMETAPA,
                   I.QTRENDINSU, I.IDSEMIACETAP, O.QTAPRODPREOP, O.IDORDPRODCON, O.CDPLANPRODOP, O.NRORDPROD,
                   O.NRSUBORDPROD, I.DSFASE
              FROM ORDPRODUCAO O, INSUMETAPA I
             WHERE O.CDFILIAL     = @V_PRODACABADO_CDFILIAL
               AND O.NRORDPRODCON = @V_PRODACABADO_NRORDPROD
               AND O.NRSUBOPCON   = @V_PRODACABADO_NRSUBORDPROD
               AND O.CDPRODUTO    = @V_PRODACABADO_CDPRODUTO
               AND O.CDFILIAL = I.CDFILIAL
               AND O.CDPRODUTO = I.CDPRODUTO
               AND O.CDPROCFABRIC = I.CDPROCFABRIC
               AND @V_PRODACABADO_IDPRODUSUPL = 'N'
            UNION ALL
            SELECT P.CDPRODUTO, P.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, I.IDUTAPRREQET, I.QTINSUMETAPA,
                   I.QTRENDINSU, I.IDSEMIACETAP, 0 QTAPRODPREOP, 'S' IDORDPRODCON, '' CDPLANPRODOP, '' NRORDPROD,
                  '' NRSUBORDPROD, I.DSFASE
              FROM PROCFABRICA P, INSUMETAPA I
             WHERE P.CDFILIAL  = @V_PRODACABADO_CDFILIAL
               AND P.CDPRODUTO = @V_PRODACABADO_CDPRODUTO
               AND P.IDPROFABPADR = 'S'
               AND @V_PRODACABADO_IDPRODUSUPL = 'S'
               AND P.CDFILIAL = I.CDFILIAL
               AND P.CDPRODUTO = I.CDPRODUTO
               AND P.CDPROCFABRIC = I.CDPROCFABRIC;
         OPEN C_INSUMO;

         FETCH NEXT FROM C_INSUMO INTO @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_INSUMO_IDUTAPRREQET, @V_INSUMO_QTINSUMETAPA,
                                       @V_INSUMO_QTRENDINSU, @V_INSUMO_IDSEMIACETAP, @V_INSUMO_QTAPRODPREOP, @V_INSUMO_IDORDPRODCON, @V_INSUMO_CDPLANPRODOP, @V_INSUMO_NRORDPROD,
                                       @V_INSUMO_NRSUBORDPROD, @V_INSUMO_DSFASE;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_COUNT = 0;
            SELECT @V_COUNT = COUNT(1)
              FROM RETIRADAESTO
             WHERE CDFILIAL     = @V_PRODACABADO_CDFILIAL
               AND NRORDPROD    = @V_PRODACABADO_NRORDPROD
               AND NRSUBORDPROD = @V_PRODACABADO_NRSUBORDPROD;

            IF @V_COUNT = 0 BEGIN
               SET @V_NOVO_CODIGO_NT = 'RETIESTO' + @V_PRODACABADO_CDFILIAL;
               EXEC NOVO_CODIGO_SC @V_NOVO_CODIGO_NT, @P_SEQUENCIAL = @V_NRRETEST OUTPUT, @P_QTDE = 1;
               SET @V_NRRETEST = SUBSTRING(@V_NRRETEST, 11, 10);

               INSERT INTO RETIRADAESTO
                 (CDFILIAL, NRRETEST, DTRETEST, NRORDPROD, NRSUBORDPROD,
                  CDETAPAPROD, CDCENTCUST, CDSETOR)
               VALUES
                 (@V_PRODACABADO_CDFILIAL, @V_NRRETEST, GETDATE(), @V_PRODACABADO_NRORDPROD,  @V_PRODACABADO_NRSUBORDPROD,
                  @V_INSUMO_CDETAPAPROD, @V_CDCENTCUST, @V_CDSETOR);

               SET @V_NRSEQRETPROD = 0;
               SELECT @V_NRSEQRETPROD = ISNULL(CONVERT(INT, MAX(NRSEQRETPROD)), 0)
                 FROM ITEMRETIEST
                WHERE CDFILIAL  = @V_PRODACABADO_CDFILIAL
                  AND NRRETEST  = @V_NRRETEST;


               INSERT INTO ITEMRETIEST
                  (CDFILIAL, NRRETEST, NRSEQRETPROD, CDPRODUTO, DTRETPROD,
                   QTPRERETPROD, CDTIPORETI, IDLOTEEXT, DSFASE)
               VALUES
                  (@V_PRODACABADO_CDFILIAL, @V_NRRETEST, RIGHT(REPLICATE('0', 4) + CONVERT(VARCHAR, (@V_NRSEQRETPROD+1)), 4), @V_INSUMO_CDPRODINSUMO, GETDATE(),
                   (TEKNISA.QTPREVI_MATPRIMA(@V_PRODACABADO_CDFILIAL, @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_PRODACABADO_QTPRODUZIDA, 'S')),
                   @V_CDTIPORETI, 'N', @V_INSUMO_DSFASE);
            END
            ELSE BEGIN

               SELECT @V_NRSEQRETPROD = MAX(I.NRSEQRETPROD), @V_NRRETEST = MAX(I.NRRETEST), @V_CDPRODUTO = MAX(I.CDPRODUTO), @V_DSFASE = MAX(I.DSFASE)
                 FROM RETIRADAESTO R, ITEMRETIEST I
                WHERE R.CDFILIAL     = @V_PRODACABADO_CDFILIAL
                  AND R.NRORDPROD    = @V_PRODACABADO_NRORDPROD
                  AND R.NRSUBORDPROD = @V_PRODACABADO_NRSUBORDPROD
                  AND R.CDFILIAL     = I.CDFILIAL
                  AND R.NRRETEST     = I.NRRETEST
                  AND I.CDPRODUTO    = @V_INSUMO_CDPRODINSUMO;

               IF @V_CDPRODUTO IS NULL BEGIN
                  SET @V_NOVO_CODIGO_NT = 'RETIESTO' + @V_PRODACABADO_CDFILIAL;
                  EXEC NOVO_CODIGO_SC @V_NOVO_CODIGO_NT, @P_SEQUENCIAL = @V_NRRETEST OUTPUT, @P_QTDE = 1;
                  SET @V_NRRETEST = SUBSTRING(@V_NRRETEST, 11, 10);

                  INSERT INTO RETIRADAESTO
                    (CDFILIAL, NRRETEST, DTRETEST, NRORDPROD, NRSUBORDPROD,
                     CDETAPAPROD, CDCENTCUST, CDSETOR)
                  VALUES
                    (@V_PRODACABADO_CDFILIAL, @V_NRRETEST, GETDATE(), @V_PRODACABADO_NRORDPROD,  @V_PRODACABADO_NRSUBORDPROD,
                     @V_INSUMO_CDETAPAPROD, @V_CDCENTCUST, @V_CDSETOR);

                  SET @V_NRSEQRETPROD = 0;
                  SELECT @V_NRSEQRETPROD = ISNULL(CONVERT(INT, MAX(NRSEQRETPROD)), 0)
                    FROM ITEMRETIEST
                   WHERE CDFILIAL  = @V_PRODACABADO_CDFILIAL
                     AND NRRETEST  = @V_NRRETEST;

                  INSERT INTO ITEMRETIEST
                     (CDFILIAL, NRRETEST, NRSEQRETPROD, CDPRODUTO, DTRETPROD,
                      QTPRERETPROD, CDTIPORETI, IDLOTEEXT, DSFASE)
                  VALUES
                     (@V_PRODACABADO_CDFILIAL, @V_NRRETEST, RIGHT(REPLICATE('0', 4) + CONVERT(VARCHAR, (@V_NRSEQRETPROD+1)), 4), @V_INSUMO_CDPRODINSUMO, GETDATE(),
                      (TEKNISA.QTPREVI_MATPRIMA(@V_PRODACABADO_CDFILIAL, @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_PRODACABADO_QTPRODUZIDA, 'S')),
                      @V_CDTIPORETI, 'N', @V_INSUMO_DSFASE);
               END
               ELSE BEGIN
                  UPDATE ITEMRETIEST
                     SET QTPRERETPROD = QTPRERETPROD + (TEKNISA.QTPREVI_MATPRIMA(@V_PRODACABADO_CDFILIAL, @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_PRODACABADO_QTPRODUZIDA, 'S'))
                   WHERE CDFILIAL     = @V_PRODACABADO_CDFILIAL
                     AND NRRETEST     = @V_NRRETEST
                     AND NRSEQRETPROD = @V_NRSEQRETPROD;

                  IF (@V_INSUMO_DSFASE <> @V_DSFASE) BEGIN
                     UPDATE ITEMRETIEST
                        SET DSFASE = NULL
                        WHERE CDFILIAL     = @V_PRODACABADO_CDFILIAL
                          AND NRRETEST     = @V_NRRETEST
                          AND NRSEQRETPROD = @V_NRSEQRETPROD;
                  END;

               END;

            END;
            FETCH NEXT FROM C_INSUMO INTO @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_INSUMO_IDUTAPRREQET, @V_INSUMO_QTINSUMETAPA,
                                          @V_INSUMO_QTRENDINSU, @V_INSUMO_IDSEMIACETAP, @V_INSUMO_QTAPRODPREOP, @V_INSUMO_IDORDPRODCON, @V_INSUMO_CDPLANPRODOP, @V_INSUMO_NRORDPROD,
                                          @V_INSUMO_NRSUBORDPROD, @V_INSUMO_DSFASE;
         END;
         CLOSE C_INSUMO;
         DEALLOCATE C_INSUMO;
      END
      ELSE BEGIN
         DECLARE C_INSUMO CURSOR FOR
            SELECT I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, I.IDUTAPRREQET, I.QTINSUMETAPA,
                   I.QTRENDINSU, I.IDSEMIACETAP, I.CDTIPOINSU, I.IDLOTEEXT, I.DSFASE
              FROM INSUMETAPA I, ETAFABRICOP E
             WHERE I.CDFILIAL     = E.CDFILIAL
               AND I.CDPRODUTO    = @V_PRODACABADO_CDPRODUTO
               AND I.CDPROCFABRIC = @V_PRODACABADO_CDPROCFABRIC
               AND E.CDFILIAL     = @V_PRODACABADO_CDFILIAL
               AND E.NRORDPROD    = @V_PRODACABADO_NRORDPROD
               AND E.NRSUBORDPROD = @V_PRODACABADO_NRSUBORDPROD
               AND E.CDETAPAPROD  = I.CDETAPAPROD
               AND @V_PRODACABADO_IDPRODUSUPL = 'N'
           UNION ALL
           SELECT P.CDPRODUTO, P.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, I.IDUTAPRREQET, I.QTINSUMETAPA,
                  I.QTRENDINSU, I.IDSEMIACETAP, I.CDTIPOINSU, I.IDLOTEEXT, I.DSFASE
             FROM PROCFABRICA P, INSUMETAPA I
            WHERE P.CDFILIAL = @V_PRODACABADO_CDFILIAL
              AND P.CDPRODUTO = @V_PRODACABADO_CDPRODUTO
              AND P.IDPROFABPADR = 'S'
              AND @V_PRODACABADO_IDPRODUSUPL = 'S'
              AND P.CDFILIAL = I.CDFILIAL
              AND P.CDPRODUTO = I.CDPRODUTO
              AND P.CDPROCFABRIC = I.CDPROCFABRIC;
         OPEN C_INSUMO;

         FETCH NEXT FROM C_INSUMO INTO @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_INSUMO_IDUTAPRREQET, @V_INSUMO_QTINSUMETAPA,
                                       @V_INSUMO_QTRENDINSU, @V_INSUMO_IDSEMIACETAP, @V_INSUMO_CDTIPOINSU, @V_INSUMO_IDLOTEEXT, @V_INSUMO_DSFASE;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_CDSETORAUX = MAX(E.CDSETOR), @V_CDCENTCUSTAUX = MAX(S.CDCENTCUST)
              FROM ETAFABRIC E, SETOR S
             WHERE E.CDFILIAL  = @V_PRODACABADO_CDFILIAL
               AND E.CDPRODUTO = @V_PRODACABADO_CDPRODUTO
               AND E.CDPROCFABRIC = @V_PRODACABADO_CDPROCFABRIC
               AND E.CDETAPAPROD = @V_INSUMO_CDETAPAPROD
               AND E.CDSETOR = S.CDSETOR;

            IF @V_CDSETORAUX IS NOT NULL BEGIN
               SET @V_CDSETOR = @V_CDSETORAUX;
            END;

            IF @V_CDCENTCUSTAUX IS NOT NULL BEGIN
               SET @V_CDCENTCUST = @V_CDCENTCUSTAUX;
            END;

            SET @V_NOVO_CODIGO_NT = 'RETIESTO' + @V_PRODACABADO_CDFILIAL;
            EXEC NOVO_CODIGO_SC @V_NOVO_CODIGO_NT, @P_SEQUENCIAL = @V_NRRETEST OUTPUT, @P_QTDE = 1;
            SET @V_NRRETEST = SUBSTRING(@V_NRRETEST, 11, 10);

            INSERT INTO RETIRADAESTO
              (CDFILIAL, NRRETEST, DTRETEST, NRORDPROD, NRSUBORDPROD,
               CDETAPAPROD, CDCENTCUST, CDSETOR)
            VALUES
              (@V_PRODACABADO_CDFILIAL, @V_NRRETEST, GETDATE(), @V_PRODACABADO_NRORDPROD, @V_PRODACABADO_NRSUBORDPROD,
               @V_INSUMO_CDETAPAPROD, @V_CDCENTCUST, @V_CDSETOR);

            SELECT @V_NRSEQRETPROD = ISNULL(CONVERT(INT, MAX(NRSEQRETPROD)), 0)
              FROM ITEMRETIEST
             WHERE CDFILIAL  = @V_PRODACABADO_CDFILIAL
               AND NRRETEST  = @V_NRRETEST
               AND CDPRODUTO = @V_INSUMO_CDPRODINSUMO;

            INSERT INTO ITEMRETIEST
               (CDFILIAL, NRRETEST, NRSEQRETPROD, CDPRODUTO, DTRETPROD,
                QTPRERETPROD, CDTIPORETI, IDLOTEEXT, DSFASE)
            VALUES
               (@V_PRODACABADO_CDFILIAL, @V_NRRETEST, RIGHT(REPLICATE('0', 4) + CONVERT(VARCHAR, (@V_NRSEQRETPROD+1)), 4), @V_INSUMO_CDPRODINSUMO, GETDATE(),
                (TEKNISA.QTPREVI_MATPRIMA(@V_PRODACABADO_CDFILIAL, @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_PRODACABADO_QTPRODUZIDA, 'S')),
                @V_CDTIPORETI, @V_INSUMO_IDLOTEEXT, @V_INSUMO_DSFASE);

            FETCH NEXT FROM C_INSUMO INTO @V_INSUMO_CDPRODUTO, @V_INSUMO_CDPROCFABRIC, @V_INSUMO_CDETAPAPROD, @V_INSUMO_CDPRODINSUMO, @V_INSUMO_IDUTAPRREQET, @V_INSUMO_QTINSUMETAPA,
                                       @V_INSUMO_QTRENDINSU, @V_INSUMO_IDSEMIACETAP, @V_INSUMO_CDTIPOINSU, @V_INSUMO_IDLOTEEXT, @V_INSUMO_DSFASE;

         END;
         CLOSE C_INSUMO;
         DEALLOCATE C_INSUMO;
      END;
      FETCH NEXT FROM C_PRODACABADO INTO @V_PRODACABADO_CDFILIAL, @V_PRODACABADO_NRORDPROD, @V_PRODACABADO_NRSUBORDPROD, @V_PRODACABADO_IDORDPRODCON, @V_PRODACABADO_CDSUBPRODETA, @V_PRODACABADO_NRSUBPRETAOP, @V_PRODACABADO_CDPRODUTO, @V_PRODACABADO_NRPRODACAB,
                                      @V_PRODACABADO_QTPRACABADO, @V_PRODACABADO_NRLANCESTQ, @V_PRODACABADO_NRSEQUITEM, @V_PRODACABADO_QTPRODUZIDA, @V_PRODACABADO_IDPRODUSUPL,
                                      @V_PRODACABADO_CDPROCFABRIC;

   END;
   CLOSE C_PRODACABADO;
   DEALLOCATE C_PRODACABADO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CALCULA_INSUMOS_PESAGEM','0.00.000';
GO

