CREATE OR REPLACE PROCEDURE DMS_LONDRINA(
   P_NRLISTA     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDEMPRESA   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_NRSEQARQMAG IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_LIVROMAG    IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_TIPOSERVICO IN NOTAFISCAL.IDENTRSAIDOP%TYPE)
AS
   V_CONTADOR    NUMBER;
BEGIN

   V_CONTADOR := 0;
   /*Servios Prestados - Notas de Sada*/
   IF P_TIPOSERVICO = 'P' THEN
      FOR C_PREST IN (SELECT NF.CDINSCMUNI    ||';'|| /*CMC do Prestador*/
                             NF.NRNOTAFISC    ||';'|| /*Nmero da Nota Inicial*/
                             NF.NRNOTAFISC    ||';'|| /*Nmero da Nota Final*/
                             NF.CDSERIE       ||';'|| /*Srie*/
                             ''               ||';'|| /*Sub-Srie*/
                             TO_CHAR(NF.DTEMISSAO,'DD')     ||';'|| /*Dia de Emissao*/
                             CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI) ||';'|| /*Cdigo do Servio*/
                             'tp'             ||';'|| /*Tomador (Situao da Nota)*/
                             REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRNOTAFISC,2), '999999999990.00')), '.', ',')        ||';'|| /*Valor da Nota*/
                             REPLACE(LTRIM(TO_CHAR(SUM(ROUND(IT.VRBASECALCIT,2)), '999999999990.00')), '.', ',') ||';'|| /*Valor do Servio*/
                             DECODE(NF.IDORIGDESTNF,'F',FO.NRINSJURFORN,'C',CL.NRINSJURCLIE,FI.NRINSJURFILI)     ||';'|| /*CNPJ do Tomador*/
                             'T'          AS DADOS_P, /*Talo*/
                             NF.NRLANCTONF, NF.CDFILIAL
                        FROM NOTAFISCAL NF, LISTA LS, ITEMPRODUTO IP, ITEMPROIMPOS IT, PRODUTO PR,
                             TPIMPOSLIVRO TI, FILIAL FI, FORNECEDOR FO, CLIENTE CL
                       WHERE LS.NRLISTA      = P_NRLISTA
                         AND SUBSTR(LS.CDLISTA,1,4) = NF.CDFILIAL
                         AND SUBSTR(LS.CDLISTA,5,10)= NF.NRLANCTONF
                         AND NF.IDENTRSAIDOP = 'S'
                         AND IP.NRLANCTONF   = NF.NRLANCTONF
                         AND IP.CDFILIAL     = NF.CDFILIAL
                         AND IP.CDPRODUTO    = PR.CDPRODUTO
                         AND IP.CDFILIAL     = IT.CDFILIAL
                         AND IP.NRLANCTONF   = IT.NRLANCTONF
                         AND IP.NRSEQITPROD  = IT.NRSEQITPROD
                         AND IT.CDIMPOSTO    = TI.CDIMPOSTOLIVRO
                         AND TI.CDLIVROMAG   = P_LIVROMAG
                         AND NF.CDFORNECED   = FO.CDFORNECED(+)
                         AND NF.CDFILIRECE   = FI.CDFILIAL(+)
                         AND NF.CDCLIENTE    = CL.CDCLIENTE(+)
                       GROUP BY DECODE(NF.IDORIGDESTNF,'F',FO.NRINSJURFORN,'C',CL.NRINSJURCLIE,FI.NRINSJURFILI), NF.CDINSCMUNI,
                                NF.NRNOTAFISC, NF.CDSERIE, NF.DTEMISSAO, NF.VRNOTAFISC, NF.NRLANCTONF, NF.CDFILIAL,
                                CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI)
                       ORDER BY NF.NRNOTAFISC) LOOP

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (V_CONTADOR, C_PREST.DADOS_P , P_NRSEQARQMAG);
         V_CONTADOR := NVL(V_CONTADOR,0)+1;
         
         UPDATE NOTAFISCAL
            SET IDEXPNFEDMSLON = 'S'
          WHERE CDFILIAL       = C_PREST.CDFILIAL
            AND NRLANCTONF     = C_PREST.NRLANCTONF;

      END LOOP;
    /*Servios Tomados - Notas de Entrada*/
   ELSE
      FOR C_TOMAD IN (SELECT DECODE(NF.IDORIGDESTNF,'F',FO.NRINSJURFORN,'C',CL.NRINSJURCLIE,FI.NRINSJURFILI) ||';'|| /*CNPJ do Prestador*/
                             NF.NRNOTAFISC   ||';'|| /*Nmero da Nota*/
                             NF.CDSERIEENTR  ||';'|| /*Srie*/
                             ''              ||';'|| /*Sub-Srie*/
                             TO_CHAR(NF.DTEMISSAO,'DD') ||';'|| /*Dia de Emissao*/
                             CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI) ||';'|| /*Cdigo do Servio*/
                             'tt'            ||';'|| /*Tomador (Situao da Nota)*/
                             REPLACE(LTRIM(TO_CHAR(SUM(ROUND(IT.VRBASECALCIT,2)), '999999999990.00')), '.', ',') || ';' ||  /*Valor do Servio*/
                             NF.CDINSCMUNI   ||';'|| /*CMC do Tomador*/
                             'T'             ||';'|| /*Tipo de Nota*/
                             ''              ||';'|| /*Alquota Simples*/
                             'C'          AS DADOS_C, /*Lanamento Concludo*/
			     NF.NRLANCTONF, NF.CDFILIAL
                        FROM NOTAFISCAL NF, LISTA LS, ITEMPRODUTO IP, ITEMPROIMPOS IT, PRODUTO PR,
                             TPIMPOSLIVRO TI, FILIAL FI, FORNECEDOR FO, CLIENTE CL
                       WHERE LS.NRLISTA       = P_NRLISTA
                         AND SUBSTR(LS.CDLISTA,1,4) = NF.CDFILIAL
                         AND SUBSTR(LS.CDLISTA,5,10)= NF.NRLANCTONF
                         AND NF.IDENTRSAIDOP  = 'E'
                         AND IP.NRLANCTONF    = NF.NRLANCTONF
                         AND IP.CDFILIAL      = NF.CDFILIAL
                         AND IP.CDPRODUTO     = PR.CDPRODUTO
                         AND IP.CDFILIAL      = IT.CDFILIAL
                         AND IP.NRLANCTONF    = IT.NRLANCTONF
                         AND IP.NRSEQITPROD   = IT.NRSEQITPROD
                         AND IT.CDIMPOSTO     = TI.CDIMPOSTOLIVRO
                         AND TI.CDLIVROMAG    = P_LIVROMAG
                         AND NF.CDFORNECED    = FO.CDFORNECED(+)
                         AND NF.CDFILIRECE    = FI.CDFILIAL(+)
                         AND NF.CDCLIENTE     = CL.CDCLIENTE(+)
                       GROUP BY DECODE(NF.IDORIGDESTNF,'F',FO.NRINSJURFORN,'C',CL.NRINSJURCLIE,FI.NRINSJURFILI),
                                NF.NRNOTAFISC, NF.CDSERIEENTR, NF.DTEMISSAO, NF.CDINSCMUNI, NF.NRLANCTONF, NF.CDFILIAL,
                                CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI)
                       ORDER BY NF.NRNOTAFISC) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (V_CONTADOR, C_TOMAD.DADOS_C , P_NRSEQARQMAG);
         V_CONTADOR := NVL(V_CONTADOR,0)+1;

         UPDATE NOTAFISCAL
            SET IDEXPNFEDMSLON = 'S'
          WHERE CDFILIAL       = C_TOMAD.CDFILIAL
            AND NRLANCTONF     = C_TOMAD.NRLANCTONF;

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DMS_LONDRINA','5.75.000'); END;
/

