/* Tabela ENDECLIE: Endereo de cliente */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ENDECLIE */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Endereos de cliente
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_GER_ENDECLIE' and
            type = 'TR'         and
            u.uid = o.uid       and
            u.name = USER)
  DROP TRIGGER LOG_GER_ENDECLIE
  GO

CREATE TRIGGER LOG_GER_ENDECLIE
ON ENDECLIE
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(2000);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);
   DECLARE @V_IDTPENDECLIE VARCHAR(80);

/* VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_COMANDO       VARCHAR(1);

   DECLARE @V_CDCLIENTE_OLD    VARCHAR(21);
   DECLARE @V_IDTPENDECLIE_OLD VARCHAR(1);
   DECLARE @V_CDPAIS_OLD       VARCHAR(4);
   DECLARE @V_SGESTADO_OLD     VARCHAR(2);
   DECLARE @V_CDMUNICIPIO_OLD  VARCHAR(4);
   DECLARE @V_DSENDECLIE_OLD   VARCHAR(50);
   DECLARE @V_NMBAIRCLIE_OLD   VARCHAR(30);
   DECLARE @V_DSCOMPENDCLI_OLD VARCHAR(200);
   DECLARE @V_NRCEPCLIE_OLD    VARCHAR(15);
   DECLARE @V_NRTELECLIE_OLD   VARCHAR(25);
   DECLARE @V_NRRAMALCLIE_OLD  VARCHAR(4);
   DECLARE @V_NRTELEXCLIE_OLD  VARCHAR(25);
   DECLARE @V_NRFAXCLIE_OLD    VARCHAR(25);
   DECLARE @V_NMCONTCLIE_OLD   VARCHAR(30);
   DECLARE @V_DSEMAILCLIE_OLD  VARCHAR(50);
   DECLARE @V_NRTELECLIE1_OLD  VARCHAR(25);
   DECLARE @V_NRRAMALCLIE1_OLD VARCHAR(4);
   DECLARE @V_NRCELULARCLI_OLD VARCHAR(25);
   DECLARE @V_NRTELRESICLI_OLD VARCHAR(25);
   DECLARE @V_DSEMAILCLIENFE_OLD VARCHAR(40);
--   DECLARE @V_DSPTOREFECLI_OLD TEXT;

   DECLARE @V_CDCLIENTE_NEW    VARCHAR(21);
   DECLARE @V_IDTPENDECLIE_NEW VARCHAR(1);
   DECLARE @V_CDPAIS_NEW       VARCHAR(4);
   DECLARE @V_SGESTADO_NEW     VARCHAR(2);
   DECLARE @V_CDMUNICIPIO_NEW  VARCHAR(4);
   DECLARE @V_DSENDECLIE_NEW   VARCHAR(50);
   DECLARE @V_NMBAIRCLIE_NEW   VARCHAR(30);
   DECLARE @V_DSCOMPENDCLI_NEW VARCHAR(200);
   DECLARE @V_NRCEPCLIE_NEW    VARCHAR(15);
   DECLARE @V_NRTELECLIE_NEW   VARCHAR(25);
   DECLARE @V_NRRAMALCLIE_NEW  VARCHAR(4);
   DECLARE @V_NRTELEXCLIE_NEW  VARCHAR(25);
   DECLARE @V_NRFAXCLIE_NEW    VARCHAR(25);
   DECLARE @V_NMCONTCLIE_NEW   VARCHAR(30);
   DECLARE @V_DSEMAILCLIE_NEW  VARCHAR(50);
   DECLARE @V_NRTELECLIE1_NEW  VARCHAR(25);
   DECLARE @V_NRRAMALCLIE1_NEW VARCHAR(4);
   DECLARE @V_NRCELULARCLI_NEW VARCHAR(25);
   DECLARE @V_NRTELRESICLI_NEW VARCHAR(25);
   DECLARE @V_DSEMAILCLIENFE_NEW VARCHAR(40);
--   DECLARE @V_DSPTOREFECLI_NEW TEXT;

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DSREMOTEADDR = ' ';
   SET @V_DSREMOTEHOST = ' ';
   SET @V_DSSERVERRDM  = ' ';
   SET @V_DSSERVMETHOD = ' ';
   SET @V_DSREMOTEOPER = ' ';
   SET @V_DESC         = ' ';
   SET @V_ITPESQ       = ' ';
   SET @V_NMOPERADOR   = ' ';
   SET @V_IDTIPOOPER   = ' ';
   SET @V_IDTPENDECLIE = ' ';

   EXEC NMUSUARIO @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
      -- NULL,

         CDCLIENTE,
         IDTPENDECLIE,
         CDPAIS,
         SGESTADO,
         CDMUNICIPIO,
         DSENDECLIE,
         NMBAIRCLIE,
         DSCOMPENDCLI,
         NRCEPCLIE,
         NRTELECLIE,
         NRRAMALCLIE,
         NRTELEXCLIE,
         NRFAXCLIE,
         NMCONTCLIE,
         DSEMAILCLIE,
         NRTELECLIE1,
         NRRAMALCLIE1,
         NRCELULARCLI,
         NRTELRESICLI,
         DSEMAILCLIENFE
      -- DSPTOREFECLI
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,

         INSERTED.CDCLIENTE,
         INSERTED.IDTPENDECLIE,
         INSERTED.CDPAIS,
         INSERTED.SGESTADO,
         INSERTED.CDMUNICIPIO,
         INSERTED.DSENDECLIE,
         INSERTED.NMBAIRCLIE,
         INSERTED.DSCOMPENDCLI,
         INSERTED.NRCEPCLIE,
         INSERTED.NRTELECLIE,
         INSERTED.NRRAMALCLIE,
         INSERTED.NRTELEXCLIE,
         INSERTED.NRFAXCLIE,
         INSERTED.NMCONTCLIE,
         INSERTED.DSEMAILCLIE,
         INSERTED.NRTELECLIE1,
         INSERTED.NRRAMALCLIE1,
         INSERTED.NRCELULARCLI,
         INSERTED.NRTELRESICLI,
         INSERTED.DSEMAILCLIENFE,
      -- INSERTED.DSPTOREFECLI,

         DELETED.CDCLIENTE,
         DELETED.IDTPENDECLIE,
         DELETED.CDPAIS,
         DELETED.SGESTADO,
         DELETED.CDMUNICIPIO,
         DELETED.DSENDECLIE,
         DELETED.NMBAIRCLIE,
         DELETED.DSCOMPENDCLI,
         DELETED.NRCEPCLIE,
         DELETED.NRTELECLIE,
         DELETED.NRRAMALCLIE,
         DELETED.NRTELEXCLIE,
         DELETED.NRFAXCLIE,
         DELETED.NMCONTCLIE,
         DELETED.DSEMAILCLIE,
         DELETED.NRTELECLIE1,
         DELETED.NRRAMALCLIE1,
         DELETED.NRCELULARCLI,
         DELETED.NRTELRESICLI,
         DELETED.DSEMAILCLIENFE
      -- DELETED.DSPTOREFECLI,
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDCLIENTE  = DELETED.CDCLIENTE

      UNION ALL

      SELECT
         'I' IDCOMANDO,

         INSERTED.CDCLIENTE,
         INSERTED.IDTPENDECLIE,
         INSERTED.CDPAIS,
         INSERTED.SGESTADO,
         INSERTED.CDMUNICIPIO,
         INSERTED.DSENDECLIE,
         INSERTED.NMBAIRCLIE,
         INSERTED.DSCOMPENDCLI,
         INSERTED.NRCEPCLIE,
         INSERTED.NRTELECLIE,
         INSERTED.NRRAMALCLIE,
         INSERTED.NRTELEXCLIE,
         INSERTED.NRFAXCLIE,
         INSERTED.NMCONTCLIE,
         INSERTED.DSEMAILCLIE,
         INSERTED.NRTELECLIE1,
         INSERTED.NRRAMALCLIE1,
         INSERTED.NRCELULARCLI,
         INSERTED.NRTELRESICLI,
         INSERTED.DSEMAILCLIENFE,
      -- INSERTED.DSPTOREFECLI,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      -- NULL,
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

                                @V_CDCLIENTE_OLD,
                                @V_IDTPENDECLIE_OLD,
                                @V_CDPAIS_OLD,
                                @V_SGESTADO_OLD,
                                @V_CDMUNICIPIO_OLD,
                                @V_DSENDECLIE_OLD,
                                @V_NMBAIRCLIE_OLD,
                                @V_DSCOMPENDCLI_OLD,
                                @V_NRCEPCLIE_OLD,
                                @V_NRTELECLIE_OLD,
                                @V_NRRAMALCLIE_OLD,
                                @V_NRTELEXCLIE_OLD,
                                @V_NRFAXCLIE_OLD,
                                @V_NMCONTCLIE_OLD,
                                @V_DSEMAILCLIE_OLD,
                                @V_NRTELECLIE1_OLD,
                                @V_NRRAMALCLIE1_OLD,
                                @V_NRCELULARCLI_OLD,
                                @V_NRTELRESICLI_OLD,
                                @V_DSEMAILCLIENFE_OLD,
                              --@V_DSPTOREFECLI_OLD,

                                @V_CDCLIENTE_NEW,
                                @V_IDTPENDECLIE_NEW,
                                @V_CDPAIS_NEW,
                                @V_SGESTADO_NEW,
                                @V_CDMUNICIPIO_NEW,
                                @V_DSENDECLIE_NEW,
                                @V_NMBAIRCLIE_NEW,
                                @V_DSCOMPENDCLI_NEW,
                                @V_NRCEPCLIE_NEW,
                                @V_NRTELECLIE_NEW,
                                @V_NRRAMALCLIE_NEW,
                                @V_NRTELEXCLIE_NEW,
                                @V_NRFAXCLIE_NEW,
                                @V_NMCONTCLIE_NEW,
                                @V_DSEMAILCLIE_NEW,
                                @V_NRTELECLIE1_NEW,
                                @V_NRRAMALCLIE1_NEW,
                                @V_NRCELULARCLI_NEW,
                                @V_NRTELRESICLI_NEW,
                                @V_DSEMAILCLIENFE_NEW;
                              --@V_DSPTOREFECLI_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'I' BEGIN
         IF @V_IDTPENDECLIE_NEW = 'P' BEGIN
            SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Principal ';
         END
         ELSE BEGIN
            IF @V_IDTPENDECLIE_NEW = 'C' BEGIN
               SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Cobrana ';
            END
            ELSE BEGIN
               IF @V_IDTPENDECLIE_NEW = 'E' BEGIN
                  SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exterior ';
               END
               ELSE BEGIN
                  IF @V_IDTPENDECLIE_NEW = 'X' BEGIN
                     SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exportao ';
                  END
                  ELSE BEGIN
                     IF @V_IDTPENDECLIE_NEW = 'T' BEGIN
                        SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Entrega ';
                     END
                     ELSE BEGIN
                        IF @V_IDTPENDECLIE_NEW = 'O' BEGIN
                           SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Outros ';
                        END
                        ELSE BEGIN
                           IF @V_IDTPENDECLIE_NEW = 'M' BEGIN
                              SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Comercial ';
                           END
                        END;
                     END;
                  END;
               END;
            END;
         END;

         SET @V_DESC = 'Cdigo do cliente:  ' + @V_CDCLIENTE_NEW    +'  '+
                       'Endereo:  '          + @V_DSENDECLIE_NEW   +'  '+
                       'Bairro:  '            + @V_NMBAIRCLIE_NEW   +'  '+ @V_IDTPENDECLIE +'  '+
                       'Complemento:  '       + @V_DSCOMPENDCLI_NEW +'  '+
                       'CEP: '                + @V_NRCEPCLIE_NEW    +'  '+
                       'Cod.Pais:  '          + @V_CDPAIS_NEW       +'  '+
                       'Cod.Estado:  '        + @V_SGESTADO_NEW     +'  '+
                       'Cod.Municipio:  '     + @V_CDMUNICIPIO_NEW  +'  '+
                       'EmailNFE: '           + @V_DSEMAILCLIENFE_NEW;

         SET @V_IDTIPOOPER = '1';
         SET @V_ITPESQ     = @V_CDCLIENTE_NEW;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U' BEGIN

            SET @V_DESC = 'Cd.Cliente:  '+ @V_CDCLIENTE_NEW +'  ' ;

            IF (@V_IDTPENDECLIE_OLD    <> @V_IDTPENDECLIE_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Tipo de Endereo:  ' + @V_IDTPENDECLIE_NEW  +'  ' ;
            END;

            IF (@V_CDPAIS_OLD    <> @V_CDPAIS_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Cod.Pais:  ' + @V_CDPAIS_NEW  +'  ' ;
            END;

            IF (@V_SGESTADO_OLD    <> @V_SGESTADO_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Estado:  ' + @V_SGESTADO_NEW  +'  ' ;
            END;

            IF (@V_CDMUNICIPIO_OLD <> @V_CDMUNICIPIO_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Cod.Municipio:  ' + @V_CDMUNICIPIO_NEW  +'  ' ;
            END;

            IF (ISNULL (@V_DSENDECLIE_OLD,'X') <> ISNULL(@V_DSENDECLIE_NEW, 'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Endereo:  ' + @V_DSENDECLIE_NEW +'  ' ;
            END;

            IF ( ISNULL(@V_NMBAIRCLIE_OLD,'X') <> ISNULL(@V_NMBAIRCLIE_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Bairro:  ' + @V_NMBAIRCLIE_NEW +'  ' ;
            END;


            IF ( ISNULL(@V_DSCOMPENDCLI_OLD,'X')   <> ISNULL(@V_DSCOMPENDCLI_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Complemento:  ' + @V_DSCOMPENDCLI_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRCEPCLIE_OLD,'X')  <> ISNULL(@V_NRCEPCLIE_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'CEP:  ' + @V_NRCEPCLIE_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRTELECLIE_OLD,'X') <>  ISNULL(@V_NRTELECLIE_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nr.Telefone:  ' + @V_NRTELECLIE_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRRAMALCLIE_OLD,'X') <> ISNULL(@V_NRRAMALCLIE_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nr.Ramal:  ' + @V_NRRAMALCLIE_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRTELEXCLIE_OLD,'X') <> ISNULL(@V_NRTELEXCLIE_NEW, 'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nr.Tel.Exterior:  ' + @V_NRTELEXCLIE_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRFAXCLIE_OLD,'X')  <> ISNULL(@V_NRFAXCLIE_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nr.Fax:  ' + @V_NRFAXCLIE_NEW  +'  ' ;
            END;

            IF (ISNULL(@V_NMCONTCLIE_OLD,'X')  <> ISNULL(@V_NMCONTCLIE_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nome da pessoa de contato no cliente:  ' + @V_NMCONTCLIE_NEW  +'  ' ;
            END;

            IF (ISNULL(@V_DSEMAILCLIE_OLD,'X') <>  ISNULL(@V_DSEMAILCLIE_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'E-MAIL:  ' + @V_DSEMAILCLIE_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRTELECLIE1_OLD,'X')<> ISNULL(@V_NRTELECLIE1_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nr.Tel2:  ' + @V_NRTELECLIE1_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRRAMALCLIE1_OLD,'X') <> ISNULL(@V_NRRAMALCLIE1_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nr.Ramal2:  ' + @V_NRRAMALCLIE1_NEW  +'  ' ;
            END;

            IF ( ISNULL(@V_NRCELULARCLI_OLD,'X') <> ISNULL(@V_NRCELULARCLI_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nr.Celular:  ' + @V_NRCELULARCLI_NEW  +'  ' ;
            END;

            IF (ISNULL(@V_NRTELRESICLI_OLD,'X')    <> ISNULL(@V_NRTELRESICLI_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Nmero do telefone residencial do cliente:  ' + @V_NRTELRESICLI_NEW  +'  ' ;
            END;

            IF ISNULL(@V_DSEMAILCLIENFE_OLD, 'Z') <> ISNULL(@V_DSEMAILCLIENFE_NEW, 'Z') BEGIN
               SET @V_DESC = @V_DESC + 'EmailNFE: ' + @V_DSEMAILCLIENFE_NEW+ '  '; 
            END;

    /*        IF (ISNULL(@V_DSPTOREFECLI_OLD,'X')    <> ISNULL(@V_DSPTOREFECLI_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Ponto de referncia para o endereo do cliente:  ' + @V_DSPTOREFECLI_NEW  +'  ' ;
            END;*/

            SET @V_IDTIPOOPER = '2';
            SET @V_ITPESQ     = @V_CDCLIENTE_NEW;
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               IF @V_IDTPENDECLIE_NEW = 'P' BEGIN
                  SET @V_IDTPENDECLIE =  'Identificador do tipo de endereo: Principal ';
               END
               ELSE BEGIN
                  IF @V_IDTPENDECLIE_OLD = 'C' BEGIN
                     SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Cobrana ';
                  END
                  ELSE BEGIN
                     IF @V_IDTPENDECLIE_OLD = 'E' BEGIN
                        SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exterior ';
                     END
                     ELSE BEGIN
                        IF @V_IDTPENDECLIE_OLD = 'X' BEGIN
                           SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exportao ';
                        END
                        ELSE BEGIN
                           IF @V_IDTPENDECLIE_OLD = 'T' BEGIN
                              SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Entrega ';
                           END
                           ELSE BEGIN
                              IF @V_IDTPENDECLIE_OLD = 'O' BEGIN
                                 SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Outros ';
                              END
                              ELSE BEGIN
                                 IF @V_IDTPENDECLIE_OLD = 'M' BEGIN
                                    SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Comercial ';
                                 END;
                              END;
                           END;
                        END;
                     END;
                  END;
               END;

               SET @V_DESC = 'Cdigo do cliente:  ' + @V_CDCLIENTE_OLD  +'  '+
                             'Endereo:  '          + @V_DSENDECLIE_OLD +'  '+
                             'Bairro:  '            + @V_NMBAIRCLIE_OLD +'  '+ @V_IDTPENDECLIE +'  '+
                             'Complemento:  '       + @V_DSCOMPENDCLI_OLD +'  '+
                             'CEP:  :  '            + @V_NRCEPCLIE_OLD +'  '+
                             'Cod.Pais:  '          + @V_CDPAIS_OLD +'  '+
                             'Cod.Estado:  '        + @V_SGESTADO_OLD +'  '+
                             'Cod.Municipio:  '     + @V_CDMUNICIPIO_OLD+ '  '+
                             'EmailNFE: '           + @V_DSEMAILCLIENFE_OLD;

               SET @V_IDTIPOOPER = '3';
               SET @V_ITPESQ     = @V_CDCLIENTE_OLD;
            END;
         END;
      END;

      IF NOT (@V_DESC IS NULL) BEGIN

         SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER)
                     VALUES   ('ENDECLIE', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                                @V_IDTIPOOPER  , @V_DESC        , @V_ITPESQ,
                                @V_DSSERVERRDM , @V_DSREMOTEADDR, @V_DSREMOTEHOST,
                                @V_DSSERVMETHOD, @V_DSREMOTEOPER);
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

                                   @V_CDCLIENTE_OLD,
                                   @V_IDTPENDECLIE_OLD,
                                   @V_CDPAIS_OLD,
                                   @V_SGESTADO_OLD,
                                   @V_CDMUNICIPIO_OLD,
                                   @V_DSENDECLIE_OLD,
                                   @V_NMBAIRCLIE_OLD,
                                   @V_DSCOMPENDCLI_OLD,
                                   @V_NRCEPCLIE_OLD,
                                   @V_NRTELECLIE_OLD,
                                   @V_NRRAMALCLIE_OLD,
                                   @V_NRTELEXCLIE_OLD,
                                   @V_NRFAXCLIE_OLD,
                                   @V_NMCONTCLIE_OLD,
                                   @V_DSEMAILCLIE_OLD,
                                   @V_NRTELECLIE1_OLD,
                                   @V_NRRAMALCLIE1_OLD,
                                   @V_NRCELULARCLI_OLD,
                                   @V_NRTELRESICLI_OLD,
                                   @V_DSEMAILCLIENFE_OLD,
                                 --@V_DSPTOREFECLI_OLD,

                                   @V_CDCLIENTE_NEW,
                                   @V_IDTPENDECLIE_NEW,
                                   @V_CDPAIS_NEW,
                                   @V_SGESTADO_NEW,
                                   @V_CDMUNICIPIO_NEW,
                                   @V_DSENDECLIE_NEW,
                                   @V_NMBAIRCLIE_NEW,
                                   @V_DSCOMPENDCLI_NEW,
                                   @V_NRCEPCLIE_NEW,
                                   @V_NRTELECLIE_NEW,
                                   @V_NRRAMALCLIE_NEW,
                                   @V_NRTELEXCLIE_NEW,
                                   @V_NRFAXCLIE_NEW,
                                   @V_NMCONTCLIE_NEW,
                                   @V_DSEMAILCLIE_NEW,
                                   @V_NRTELECLIE1_NEW,
                                   @V_NRRAMALCLIE1_NEW,
                                   @V_NRCELULARCLI_NEW,
                                   @V_NRTELRESICLI_NEW,
                                   @V_DSEMAILCLIENFE_NEW;
                                 --@V_DSPTOREFECLI_NEW;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

